import java.applet.*;
import java.awt.*;
import java.io.*;
import java.util.*;
import java.net.*;

public class TestAppletNamed3 extends Applet
{
  public void init () throws java.io.IOException
  {
    try
      {
        java.lang.Thread.sleep (2000);
      }
    catch (java.lang.InterruptedException e)
      {}
    System.out.println ("TestAppletNamed3.init");

    // Assume the other two applets have loaded by now.  That is,
    // applets named 1 and 2 should appear before 3 in the html file.
    AppletContext ac = getAppletContext ();

    if (ac == null)
      {
	System.err.println ("error: applet context in applet 3 is null");
	return;
      }

    // Test that setStream works.
    ac.setStream ("applet 3 stream 1", new PipedInputStream ());

    // Test that addApplet worked and that getApplet works.
    Applet a1 = ac.getApplet ("TestAppletNamed1");

    if (a1 != null)
      System.out.println ("called AppletContext.getApplet, got: " + a1.getParameter ("name"));
    else
      System.out.println ("getApplet didn't work");

    // Test that getApplets works.
    Enumeration e = ac.getApplets ();
    while (e.hasMoreElements ())
      {
        Applet a = (Applet) e.nextElement ();
        if (a != null)
          System.out.println ("called AppletContext.getApplets, got: " + a.getParameter ("name"));
        else
          System.out.println ("called AppletContext.getApplets, got null");
      }

    // Test that getStream works.
    InputStream is = ac.getStream ("applet 1 stream 2");

    if (is != null)
      System.out.println ("called AppletContext.getStream, got: applet 1 stream 2");

    // Test that getStreamKeys works.
    Iterator i = ac.getStreamKeys ();

    if (i != null)
      {
        while (i.hasNext ())
          System.out.println ("called AppletContext.getStreamKeys, got: " + (String) i.next ());
      }
    else
      System.out.println ("Didn't get any streams");

    // Test that showDocument methods can be called.
    ac.showDocument (null);
    ac.showDocument (null, "_self");

    // Test that showStatus doesn't throw an exception.
    ac.showStatus ("applets running");
  }

  public void start ()
  {
    System.out.println ("TestAppletNamed3.start");
    System.out.println ("applet 3 current keyboard manager: " + KeyboardFocusManager.getCurrentKeyboardFocusManager ());
  }
}
